/********************************** (C) COPYRIGHT *******************************
* File Name          : CH56x_usb30.c
* Author             : WCH
* Version            : V1.1
* Date               : 2020/12/31
* Description 		 :
*******************************************************************************/
#include "CH56x_common.h"
#include "CH56x_USB30_LIB.H"
#include "CH56x_usb20.h"
#include "CH56x_usb30.h"
/* Global define */
//#define UsbSetupBuf     ((PUSB_SETUP)endp0RTbuff)//˵0


/* Global Variable */
UINT8V tx_lmp_port = 0;
UINT8V link_sta = 0;
UINT32V vitrul_buad  = 115200;
static UINT32 SetupLen = 0;
static UINT8 SetupReqCode = 0;
static PUINT8 pDescr;
__attribute__ ((aligned(16))) UINT8 endp0RTbuff[512]  __attribute__((section(".DMADATA"))); //˵0շ
__attribute__ ((aligned(16))) UINT8 endp1RTbuff[4096] __attribute__((section(".DMADATA"))); //˵1շ
__attribute__ ((aligned(16))) UINT8 endp2RTbuff[4096] __attribute__((section(".DMADATA"))); //˵2շ
__attribute__ ((aligned(16))) UINT8 endp3RTbuff[4096] __attribute__((section(".DMADATA"))); //˵3շ
__attribute__ ((aligned(16))) UINT8 endp4RTbuff[4096] __attribute__((section(".DMADATA"))); //˵4շ
__attribute__ ((aligned(16))) UINT8 endp5RTbuff[4096] __attribute__((section(".DMADATA"))); //˵5շ
__attribute__ ((aligned(16))) UINT8 endp6RTbuff[4096] __attribute__((section(".DMADATA"))); //˵6շ
__attribute__ ((aligned(16))) UINT8 endp7RTbuff[4096] __attribute__((section(".DMADATA"))); //˵7շ

/*豸*/
const UINT8 SS_DeviceDescriptor[] =
{
    0x12,   // bLength
    0x01,   // DEVICE descriptor type
    0x00,   // 3.00
    0x03,

    2,  // device class
    0,  // device sub-class
    0,  // vendor specific protocol

    0x09,   // max packet size 512B

    0xF4,   // vendor id-0x1A86(qinheng)
    0xF6,
    0x05,   // product id 0x8080
    0x00,

    0x00,   // bcdDevice 0x0011
    0x01,

    0x00,   // manufacturer index string
    0x00,   // product index string
    0x00,   // serial number index string

    0x01    // number of configurations
};

/**/
const UINT8 SS_ConfigDescriptor[] =
{
     0x09,   // length of this descriptor
     0x02,   // CONFIGURATION (2)
     85,   // total length includes endpoint descriptors (should be 1 more than last address)
     0x00,   // total length high byte
     0x02,   // number of interfaces
     0x01,   // configuration value for this one
     0x00,   // configuration - string is here, 0 means no string
     0x80,   // attributes - bus powered, no wakeup
     0x64,   // max power - 800 ma is 100 (64 hex)

 //ƽӿ
     0x09,   // length of the interface descriptor
     0x04,   // INTERFACE (4)
     0x00,   // Zero based index 0f this interface
     0x00,   // Alternate setting value (?)
     0x01,   // Number of endpoints (not counting 0)
     0x02,   // Interface class, ff is vendor specific
     0x02,   // Interface sub-class
     0x01,   // Interface protocol
     0x00,   // Index to string descriptor for this interface

 ///*Header Functional Descriptor*/
     0x05,   /* bLength: Endpoint Descriptor size */
     0x24,   /* bDescriptorType: CS_INTERFACE */
     0x00,   /* bDescriptorSubtype: Header Func Desc */
     0x10,   /* bcdCDC: spec release number */
     0x01,
 //    /*Call Management Functional Descriptor*/
     0x05,   /* bFunctionLength */
     0x24,   /* bDescriptorType: CS_INTERFACE */
     0x01,   /* bDescriptorSubtype: Call Management Func Desc */
     0x01,
     0x00,

     0x04,
     0x24,
     0x02,
     0x02,

     0x05,
     0x24,
     0x06,
     0x00,
     0x01,


     0x07,   // length of this endpoint descriptor
     0x05,   // ENDPOINT (5)
     0x81,   // endpoint direction (80 is in) and address
     0x03,   // transfer type - 00 = control, 01 = iso, 10 = bulk, 11 = int
     0x00,   // max packet size - 1024 bytes
     0x04,   // max packet size - high
     0x08,   // polling interval in milliseconds (1 for iso)

     0x06,   // length of this endpoint compansion descriptor
     0x30,
     0x00,   // max burst size
     0x00,   // no stream
     0x00,
     0x00,



 //ݽӿ
     0x09,   // length of the interface descriptor
     0x04,   // INTERFACE (4)
     0x01,   // Zero based index 0f this interface
     0x00,   // Alternate setting value (?)
     0x02,   // Number of endpoints (not counting 0)
     0x02,   // Interface class, ff is vendor specific
     0x0a,   // Interface sub-class
     0x00,   // Interface protocol
     0x00,   // Index to string descriptor for this interface

 //Endpoint 1 Descriptor
     0x07,   // length of this endpoint descriptor
     0x05,   // ENDPOINT (5)
     0x82,   // endpoint direction (80 is in) and address
     0x02,   // transfer type - 00 = control, 01 = iso, 10 = bulk, 11 = int
     0x00,   // max packet size - 1024 bytes
     0x04,   // max packet size - high
     0x00,   // polling interval in milliseconds (1 for iso)
     0x06,   // length of this endpoint compansion descriptor
     0x30,
     0x00,   // max burst size
     0x00,   // no stream
     0x00,
     0x00,

 //endp2_descriptor
     0x07,   // length of this endpoint descriptor
     0x05,   // ENDPOINT (5)
     0x02,   // endpoint direction (00 is out) and address
     0x02,   // transfer type - 00 = control, 01 = iso, 10 = bulk, 11 = int
     0x00,   // max packet size - 1024 bytes
     0x04,   // max packet size - high
     0x00,    // polling interval in milliseconds (1 for iso)
     0x06,   // length of this endpoint compansion descriptor
     0x30,
     0x00,   // max burst size
     0x00,   // no stream
     0x00,
     0x00
};

// ===== String Descriptor Lang ID=====
// ====================================//

const UINT8 StringLangID[] =
{
    0x04,   // this descriptor length
    0x03,   // descriptor type
    0x09,   // Language ID 0 low byte
    0x04    // Language ID 0 high byte
};


// ====================================
// =====   String Descriptor 1    =====
// ====================================
const UINT8 StringVendor[] =
{
    0x08,   // length of this descriptor
    0x03,
    'W',
    0x00,
    'C',
    0x00,
    'H',
    0x00
};

// ====================================
// =====   String Descriptor 2    =====
// ====================================
const UINT8 StringProduct[]=
{
    38,         //ĳΪ38ֽ
    0x03,       //ַͱΪ0x03
    0x57, 0x00, //W
    0x43, 0x00, //C
    0x48, 0x00, //H
    0x20, 0x00, //
    0x55, 0x00, //U
    0x53, 0x00, //S
    0x42, 0x00, //B
    0x33, 0x00, //3
    0x2e, 0x00, //.
    0x30, 0x00, //0
    0x20, 0x00, //
    0x44, 0x00, //D
    0x45, 0x00, //E
    0x56, 0x00, //V
    0x49, 0x00, //I
    0x43, 0x00, //C
    0x45, 0x00, //E
    0x20, 0x00
};

// ====================================
// =====   String Descriptor 3    =====
// ====================================
UINT8 StringSerial[] =
{
    0x16,   // length of this descriptor
    0x03,
    '0',
    0x00,
    '1',
    0x00,
    '2',
    0x00,
    '3',
    0x00,
    '4',
    0x00,
    '5',
    0x00,
    '6',
    0x00,
    '7',
    0x00,
    '8',
    0x00,
    '9',
    0x00,
};

const UINT8 OSStringDescriptor[] =
{
    0x12,   // length of this descriptor
    0x03,
    'M',
    0x00,
    'S',
    0x00,
    'F',
    0x00,
    'T',
    0x00,
    '1',
    0x00,
    '0',
    0x00,
    '0',
    0x00,
    0x01,
    0x00
};

const UINT8 BOSDescriptor[] =
{
    0x05,   // length of this descriptor
    0x0f,   // CONFIGURATION (2)
    0x16,   // total length includes endpoint descriptors (should be 1 more than last address)
    0x00,   // total length high byte
    0x02,   // number of device cap

//dev_cap_descriptor1
    0x07,
    0x10,   // DEVICE CAPABILITY type
    0x02,   // USB2.0 EXTENSION
    0x06,
    0x00,
    0x00,
    0x00,

//dev_cap_descriptor2
    0x0a,   // length of this descriptor
    0x10,   // DEVICE CAPABILITY type
    0x03,   // superspeed usb device capability
    0x00,   //
    0x0e,   // ss/hs/fs
    0x00,
    0x01,   // the lowest speed is full speed
    0x0a,   // u1 exit latency is 10us
    0xff,   // u1 exit latency is 8us
    0x07
};

const UINT8 MSOS20DescriptorSet[] =
{
    // Microsoft OS 2.0 Descriptor Set Header
    0x0A, 0x00,             // wLength - 10 bytes
    0x00, 0x00,             // MSOS20_SET_HEADER_DESCRIPTOR
    0x00, 0x00, 0x03, 0x06, // dwWindowsVersion ÿ 0x06030000 for Windows Blue
    0x48, 0x00,             // wTotalLength ÿ 72 bytes
    // Microsoft OS 2.0 Registry Value Feature Descriptor
    0x3E, 0x00,             // wLength - 62 bytes
    0x04, 0x00,             // wDescriptorType ÿ 4 for Registry Property
    0x04, 0x00,             // wPropertyDataType - 4 for REG_DWORD
    0x30, 0x00,              // wPropertyNameLength ÿ 48 bytes
    0x53, 0x00, 0x65, 0x00, // Property Name - SelectiveSuspendEnabled
    0x6C, 0x00, 0x65, 0x00,
    0x63, 0x00, 0x74, 0x00,
    0x69, 0x00, 0x76, 0x00,
    0x65, 0x00, 0x53, 0x00,
    0x75, 0x00, 0x73, 0x00,
    0x70, 0x00, 0x65, 0x00,
    0x6E, 0x00, 0x64, 0x00,
    0x45, 0x00, 0x6E, 0x00,
    0x61, 0x00, 0x62, 0x00,
    0x6C, 0x00, 0x65, 0x00,
    0x64, 0x00, 0x00, 0x00,
    0x04, 0x00,             // wPropertyDataLength ÿ 4 bytes
    0x01, 0x00, 0x00, 0x00  // PropertyData - 0x00000001
};

const UINT8 PropertyHeader[] =
{
    0x8e, 0x00, 0x00, 0x00, 0x00, 01, 05, 00, 01, 00,
    0x84, 0x00, 0x00, 0x00,
    0x01, 0x00, 0x00, 0x00,
    0x28, 0x00,
    0x44, 0x00, 0x65, 0x00, 0x76, 0x00, 0x69, 0x00, 0x63, 0x00, 0x65, 0x00, 0x49, 0x00, 0x6e,
    0x00, 0x74, 0x00, 0x65, 0x00, 0x72, 0x00, 0x66, 0x00, 0x61, 0x00, 0x63, 0x00, 0x65, 0x00, 0x47, 0x00, 0x55, 0x00, 0x49, 0x00, 0x44, 0x00, 0x00, 0x00,

    0x4e, 0x00, 0x00, 0x00,
    0x7b, 0x00, 0x31, 0x00, 0x32, 0x00, 0x33, 0x00, 0x34, 0x00, 0x35, 0x00, 0x36, 0x00, 0x37, 0x00, 0x38, 0x00,
    0x2d, 0x00, 0x31, 0x00, 0x32, 0x00, 0x33, 0x00, 0x34, 0x00,
    0x2d ,0x00, 0x31, 0x00, 0x32, 0x00, 0x33, 0x00, 0x34, 0x00,
    0x2d, 0x00, 0x31, 0x00, 0x32, 0x00, 0x33, 0x00, 0x34, 0x00, 0x2d, 0x00, 0x31, 0x00, 0x32, 0x00, 0x33, 0x00,
    0x34, 0x00, 0x35, 0x00, 0x36, 0x00, 0x37, 0x00, 0x38, 0x00, 0x39, 0x00, 0x41, 0x00, 0x42, 0x00, 0x43, 0x00,
    0x7d, 0x00, 0x00, 0x00
};

const UINT8 CompactId[] =
{
    0x28, 0x00, 0x00, 0x00, 0x00, 0x01, 0x04, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01,
    0x57, 0x49, 0x4e, 0x55, 0x53, 0x42, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

UINT8 GetStatus[] =
{
    0x01, 0x00
};

/*******************************************************************************
* Function Name  : USB30_BUS_RESET
* Description    : USB3.0߸λѡλʽֻλUSBķʽ⣬ԲøλƬķʽ
* Input          : None
* Return         : None
*******************************************************************************/
void USB30_BUS_RESET( ){
//ʽ1   λUSB3.0
    USB30D_init(DISABLE);  //USB3.0ʼ
    mDelaymS(30);
    USB30D_init(ENABLE);  //USB3.0ʼ
//ʽ2   ֱӸλƬ
//    R8_SAFE_ACCESS_SIG = 0x57; // enable safe access mode
//    R8_SAFE_ACCESS_SIG = 0xa8;
//    R8_RST_WDOG_CTRL = 0x40 | RB_SOFTWARE_RESET;
}

/*******************************************************************************
* Function Name  : USB30D_init
* Description    : USB3.0豸ʼ
* Input          : None
* Return         : None
*******************************************************************************/
void USB30D_init(FunctionalState sta) {
    UINT16 i,s;
    if (sta) {
        s = USB30_Device_Init();
        if(s){
            printf("Init err\n");
            while(1);
        }
        USBSS->UEP0_DMA     = (UINT32)(UINT8 *)endp0RTbuff;
        USBSS->UEP1_TX_DMA  = (UINT32)(UINT8 *)endp1RTbuff;
        USBSS->UEP2_TX_DMA  = (UINT32)(UINT8 *)endp2RTbuff;
        USBSS->UEP3_TX_DMA  = (UINT32)(UINT8 *)endp3RTbuff;
        USBSS->UEP4_TX_DMA  = (UINT32)(UINT8 *)endp4RTbuff;
        USBSS->UEP5_TX_DMA  = (UINT32)(UINT8 *)endp5RTbuff;
        USBSS->UEP6_TX_DMA  = (UINT32)(UINT8 *)endp6RTbuff;
        USBSS->UEP7_TX_DMA  = (UINT32)(UINT8 *)endp7RTbuff;

        USBSS->UEP1_RX_DMA  = (UINT32)(UINT8 *)endp1RTbuff;
        USBSS->UEP2_RX_DMA  = (UINT32)(UINT8 *)endp2RTbuff;
        USBSS->UEP3_RX_DMA  = (UINT32)(UINT8 *)endp3RTbuff;
        USBSS->UEP4_RX_DMA  = (UINT32)(UINT8 *)endp4RTbuff;
        USBSS->UEP5_RX_DMA  = (UINT32)(UINT8 *)endp5RTbuff;
        USBSS->UEP6_RX_DMA  = (UINT32)(UINT8 *)endp6RTbuff;
        USBSS->UEP7_RX_DMA  = (UINT32)(UINT8 *)endp7RTbuff;

        USBSS->UEP_CFG = EP0_R_EN | EP0_T_EN | EP1_R_EN | EP1_T_EN | EP2_R_EN | EP2_T_EN | EP3_R_EN | EP3_T_EN
                       | EP4_R_EN | EP4_T_EN | EP5_R_EN | EP5_T_EN | EP6_R_EN | EP6_T_EN | EP7_R_EN | EP7_T_EN;// set end point rx/tx enable

        USB30_OUT_Set(ENDP_1, ACK, 1);    // endpoint1 receive setting
        USB30_OUT_Set(ENDP_2, ACK, 1);

    }
    else {
        USB30_Switch_Powermode(POWER_MODE_2);
        USBSS->LINK_CFG = PIPE_RESET | LFPS_RX_PD;
        USBSS->LINK_CTRL = GO_DISABLED | POWER_MODE_3;
        USBSS->LINK_INT_CTRL = 0;
        USB30_Device_forceclr();
    }
}

/*******************************************************************************
* Function Name  : USB30_NonStandardReq
* Description    : USB3.0Ǳ׼
* Input          : None
* Return         : 
*******************************************************************************/
UINT16 USB30_NonStandardReq() {
    SetupReqCode = UsbSetupBuf->bRequest;
    SetupLen = UsbSetupBuf->wLength;
    UINT16 len = 0;
    printf("NS:%x %x %x %x %x %x %x %x\n", endp0RTbuff[0], endp0RTbuff[1],
            endp0RTbuff[2], endp0RTbuff[3], endp0RTbuff[4], endp0RTbuff[5],
            endp0RTbuff[6], endp0RTbuff[7]);
    switch (SetupReqCode) {
        case 0x20:   //򿪴ڲ·
            printf("n20\n");
            USB30_OUT_Set(ENDP_0, ACK, 1 );
            break;
        case 0x21:   //ȡǰ
            printf("n21\n");
            *(UINT32  *)&endp0RTbuff[50] = vitrul_buad;
            endp0RTbuff[54]=0x00;endp0RTbuff[55]=0x00;endp0RTbuff[56]=0x08;
            SetupLen = 7;
            break;
        case 0x22:   //رմ
            printf("n22\n");
            break;
        case 0x02:                                                          //û
            switch (UsbSetupBuf->wIndexL) {
            case 0x05:
                if (SetupLen > SIZE_PropertyHeader)
                    SetupLen = SIZE_PropertyHeader;
                pDescr = (PUINT8) PropertyHeader;
                break;
            default:
                SetupReqCode = INVALID_REQ_CODE;
                return USB_DESCR_UNSUPPORTED;
                break;
            }
            break;
        default:
            printf("stall\n");
            SetupReqCode = INVALID_REQ_CODE;
            return USB_DESCR_UNSUPPORTED;
            break;
    }
    len = SetupLen >= ENDP0_MAXPACK ? ENDP0_MAXPACK : SetupLen;        // δ䳤
    memcpy(endp0RTbuff, &endp0RTbuff[50], len);     // device  /* ϴ */
    SetupLen -= len;
    pDescr += len;
    return len;
}

/*******************************************************************************
* Function Name  : USB30_StandardReq
* Description    : USB3.0׼
* Input          : None
* Return         : 
*******************************************************************************/
UINT16 USB30_StandardReq() {
    UINT16 len = 0;

    SetupReqCode = UsbSetupBuf->bRequest;
    SetupLen = UsbSetupBuf->wLength;

    printf("S:%x %x %x %x %x %x %x %x\n", endp0RTbuff[0], endp0RTbuff[1],
            endp0RTbuff[2], endp0RTbuff[3], endp0RTbuff[4], endp0RTbuff[5],
            endp0RTbuff[6], endp0RTbuff[7]);

    if (( UsbSetupBuf->bRequestType & USB_REQ_TYP_MASK) != USB_REQ_TYP_STANDARD){
       len= USB30_NonStandardReq();
    }
    else
    {
        switch (SetupReqCode) {
            case USB_GET_DESCRIPTOR:
                switch (UsbSetupBuf->wValueH) {
                    case USB_DESCR_TYP_DEVICE:
                        if (SetupLen > SIZE_DEVICE_DESC)
                            SetupLen = SIZE_DEVICE_DESC;
                        pDescr = (PUINT8) SS_DeviceDescriptor;
                        break;
                    case USB_DESCR_TYP_CONFIG:
                        if (SetupLen > SIZE_CONFIG_DESC)
                            SetupLen = SIZE_CONFIG_DESC;
                        pDescr = (PUINT8) SS_ConfigDescriptor;
                        break;
                    case USB_DESCR_TYP_BOS:
                        if (SetupLen > SIZE_BOS_DESC)
                            SetupLen = SIZE_BOS_DESC;
                        pDescr = (PUINT8) BOSDescriptor;
                        break;
                    case USB_DESCR_TYP_STRING:
                        switch (UsbSetupBuf->wValueL) {
                            case USB_DESCR_LANGID_STRING:
                                if (SetupLen > SIZE_STRING_LANGID)
                                    SetupLen = SIZE_STRING_LANGID;
                                pDescr = (PUINT8) StringLangID;
                                break;
                            case USB_DESCR_VENDOR_STRING:
                                if (SetupLen > SIZE_STRING_VENDOR)
                                    SetupLen = SIZE_STRING_VENDOR;
                                pDescr = (PUINT8) StringVendor;
                                break;
                            case USB_DESCR_PRODUCT_STRING:
                                if (SetupLen > SIZE_STRING_PRODUCT)
                                    SetupLen = SIZE_STRING_PRODUCT;
                                pDescr = (PUINT8) StringProduct;
                                break;
                            case USB_DESCR_SERIAL_STRING:
                                if (SetupLen > SIZE_STRING_SERIAL)
                                    SetupLen = SIZE_STRING_SERIAL;
                                pDescr = (PUINT8) StringSerial;
                                break;
                            case USB_DESCR_OS_STRING:
                                if (SetupLen > SIZE_STRING_OS)
                                    SetupLen = SIZE_STRING_OS;
                                pDescr = (PUINT8) OSStringDescriptor;
                                break;
                            default:
                                len = USB_DESCR_UNSUPPORTED;                           //ֵ֧
                                SetupReqCode = INVALID_REQ_CODE;                        //Ч
                                break;
                        }
                        break;
                    default:
                        len = USB_DESCR_UNSUPPORTED;                            //ֵ֧
                        SetupReqCode = INVALID_REQ_CODE;
                        break;
                    }
                len = SetupLen >= ENDP0_MAXPACK ? ENDP0_MAXPACK : SetupLen;    // δ䳤
                memcpy(endp0RTbuff, pDescr, len);                // device  /* ϴ */
                SetupLen -= len;
                pDescr += len;
                break;
            case USB_SET_ADDRESS:
                SetupLen = UsbSetupBuf->wValueL;                      // ݴUSB豸ַ
                break;
            case 0x31:
                SetupLen = UsbSetupBuf->wValueL;                      // ݴUSB豸ַ
                break;
            case 0x30:
                break;
            case USB_SET_CONFIGURATION:
                break;
            case USB_GET_STATUS:
                len = 2;
                endp0RTbuff[0] = 0x01;
                endp0RTbuff[1] = 0x00;
                SetupLen = 0;
                break;
            case USB_CLEAR_FEATURE:
                break;
            case USB_SET_FEATURE:
                break;
            case USB_SET_INTERFACE:
                break;
            default:
                len = USB_DESCR_UNSUPPORTED;                            //stallֵ֧
                SetupReqCode = INVALID_REQ_CODE;
                printf(" stall \n");
                break;
        }
    }
    return len;
}

/*******************************************************************************
* Function Name  : EP0_IN_Callback
* Description    : USB3.0˵0INص
* Input          : None
* Return         : None
*******************************************************************************/
UINT16 EP0_IN_Callback(void) {
    UINT16 len = 0;
    switch (SetupReqCode) {
        case USB_GET_DESCRIPTOR:
            len = SetupLen >= ENDP0_MAXPACK ? ENDP0_MAXPACK : SetupLen;
            memcpy(endp0RTbuff, pDescr, len);
            SetupLen -= len;
            pDescr += len;
            break;
    }
    return len;
}

/*******************************************************************************
* Function Name  : EP0_OUT_Callback
* Description    : USB3.0˵0OUTص
* Input          : None
* Return         : None
*******************************************************************************/
UINT16 EP0_OUT_Callback() {
//    vitrul_buad = *(UINT32 *)endp0RTbuff;
    printf("ep0out:%d\n",vitrul_buad);
    return 0;
}

/*******************************************************************************
* Function Name  : USB30_Setup_Status
* Description    : USB3.0ƴ״̬׶λص
* Input          : None
* Return         : None
*******************************************************************************/
void USB30_Setup_Status(void) {
    switch (SetupReqCode) {
    case USB_SET_ADDRESS:
        USB30_Device_Setaddress(SetupLen);                             // SET ADDRESS
        break;
    case 0x31:
        break;
    }
}

/*******************************************************************************
* Function Name  : USBSS_IRQHandler
* Description    : USB3.0 Interrupt Handler.
* Input          : None
* Return         : None
*******************************************************************************/
void USBSS_IRQHandler (void)            //USBSS interrupt service
{
    USB30_IRQHandler();
}

/*******************************************************************************
* Function Name  : TMR0_IRQHandler
* Description    : USB3.0ʧܳʱ
* Input          : None
* Return         : None
*******************************************************************************/
void TMR0_IRQHandler( ) {
    R8_TMR0_INTER_EN |= 1;
    PFIC_DisableIRQ(TMR0_IRQn);
    R8_TMR0_CTRL_MOD = RB_TMR_ALL_CLEAR;
    if(link_sta == 1 ){
        link_sta =0;
        PFIC_DisableIRQ(USBSS_IRQn);
        PFIC_DisableIRQ(LINK_IRQn);
        USB30D_init(DISABLE);
        return;
    }
    if(link_sta != 3){
        PFIC_DisableIRQ(USBSS_IRQn);
        PFIC_DisableIRQ(LINK_IRQn);
        USB30D_init(DISABLE);
        PRINT("USB2.0\n");
        R32_USB_CONTROL = 0;
        PFIC_EnableIRQ(USBHS_IRQn);
        USB20_Device_Init(ENABLE);
    }
    link_sta=1;
    return;
}


/*******************************************************************************
* Function Name  : LINK_IRQHandler
* Description    : USB3.0 Link Interrupt Handler.
* Input          : None
* Return         : None
*******************************************************************************/
void LINK_IRQHandler (  )            //USB3.0 Link interrupt service          //USBSS link interrupt service
{
    if(USBSS->LINK_INT_FLAG & LINK_Ux_EXIT_FLAG) // device enter U2
    {
        USBSS->LINK_CFG = CFG_EQ_EN | DEEMPH_CFG | TERM_EN;
        USB30_Switch_Powermode(POWER_MODE_0);
        USBSS->LINK_INT_FLAG = LINK_Ux_EXIT_FLAG;
    }
    if(USBSS->LINK_INT_FLAG & LINK_RDY_FLAG) // POLLING SHAKE DONE
    {
        USBSS->LINK_INT_FLAG = LINK_RDY_FLAG;
        if(tx_lmp_port) // LMP, TX PORT_CAP & RX PORT_CAP
        {
            USBSS->LMP_TX_DATA0 = LINK_SPEED | PORT_CAP | LMP_HP;
            USBSS->LMP_TX_DATA1 = UP_STREAM | NUM_HP_BUF;
            USBSS->LMP_TX_DATA2 = 0x0;
            tx_lmp_port = 0;
        }
        //ɹUSB3.0ͨѶ
        link_sta = 3;
        PFIC_DisableIRQ(TMR0_IRQn);
        R8_TMR0_CTRL_MOD = RB_TMR_ALL_CLEAR;
        R8_TMR0_INTER_EN = 0;
        PFIC_DisableIRQ(USBHS_IRQn);
        USB20_Device_Init(DISABLE);
    }

    if(USBSS->LINK_INT_FLAG & LINK_INACT_FLAG)
    {
        USBSS->LINK_INT_FLAG = LINK_INACT_FLAG;
        USB30_Switch_Powermode(POWER_MODE_2);
    }
    if(USBSS->LINK_INT_FLAG & LINK_DISABLE_FLAG) // GO DISABLED
    {
        USBSS->LINK_INT_FLAG = LINK_DISABLE_FLAG;
        link_sta = 1;
        USB30D_init(DISABLE);
        PFIC_DisableIRQ(USBSS_IRQn);
        R8_TMR0_CTRL_MOD = RB_TMR_ALL_CLEAR;
        R8_TMR0_INTER_EN = 0;
        PFIC_DisableIRQ(TMR0_IRQn);
        PFIC_EnableIRQ(USBHS_IRQn);
        USB20_Device_Init(ENABLE);
    }
    if(USBSS->LINK_INT_FLAG & LINK_RX_DET_FLAG)
    {
        USBSS->LINK_INT_FLAG = LINK_RX_DET_FLAG;
        USB30_Switch_Powermode(POWER_MODE_2);
    }
    if(USBSS->LINK_INT_FLAG & TERM_PRESENT_FLAG) // term present , begin POLLING
    {
        USBSS->LINK_INT_FLAG = TERM_PRESENT_FLAG;
        if(USBSS->LINK_STATUS & LINK_PRESENT)
        {
            USB30_Switch_Powermode(POWER_MODE_2);
            USBSS->LINK_CTRL |= POLLING_EN;
        }
        else
        {
            USBSS->LINK_INT_CTRL = 0;
            mDelayuS(2000);
            USB30_BUS_RESET();
        }
    }
    if(USBSS->LINK_INT_FLAG & LINK_TXEQ_FLAG) // POLLING SHAKE DONE
    {
        tx_lmp_port = 1;
        USBSS->LINK_INT_FLAG = LINK_TXEQ_FLAG;
        USB30_Switch_Powermode(POWER_MODE_0);
    }
    if(USBSS->LINK_INT_FLAG & WARM_RESET_FLAG)
    {
        USBSS->LINK_INT_FLAG = WARM_RESET_FLAG;
        USB30_Switch_Powermode(POWER_MODE_2);
        USB30_BUS_RESET();
        USB30_Device_Setaddress(0);
        USBSS->LINK_CTRL |= TX_WARM_RESET;
        while(USBSS->LINK_STATUS & RX_WARM_RESET)
            ;
        USBSS->LINK_CTRL &= ~TX_WARM_RESET;
        mDelayuS(2);
        //        printf("warm reset\n");
    }
    if(USBSS->LINK_INT_FLAG & HOT_RESET_FLAG) //ܻ·hot reset,ע˵
    {
        USBSS->USB_CONTROL |= 1 << 31;
        USBSS->LINK_INT_FLAG = HOT_RESET_FLAG; // HOT RESET begin
        USBSS->UEP0_TX_CTRL = 0;
        USB30_IN_Set(1, DISABLE, NRDY, 0, 0);
        USB30_IN_Set(2, DISABLE, NRDY, 0, 0);
        USB30_IN_Set(3, DISABLE, NRDY, 0, 0);
        USB30_IN_Set(4, DISABLE, NRDY, 0, 0);
        USB30_IN_Set(5, DISABLE, NRDY, 0, 0);
        USB30_IN_Set(6, DISABLE, NRDY, 0, 0);
        USB30_IN_Set(7, DISABLE, NRDY, 0, 0);
        USB30_OUT_Set(8, NRDY, 0);
        USB30_OUT_Set(9, NRDY, 0);
        USB30_OUT_Set(3, NRDY, 0);
        USB30_OUT_Set(4, NRDY, 0);
        USB30_OUT_Set(5, NRDY, 0);
        USB30_OUT_Set(6, NRDY, 0);
        USB30_OUT_Set(7, NRDY, 0);

        USB30_Device_Setaddress(0);
        USBSS->LINK_CTRL &= ~TX_HOT_RESET; // HOT RESET end
    }
    if(USBSS->LINK_INT_FLAG & LINK_GO_U1_FLAG) // device enter U1
    {
        USB30_Switch_Powermode(POWER_MODE_1);
        USBSS->LINK_INT_FLAG = LINK_GO_U1_FLAG;
    }
    if(USBSS->LINK_INT_FLAG & LINK_GO_U2_FLAG) // device enter U2
    {
        USB30_Switch_Powermode(POWER_MODE_2);
        USBSS->LINK_INT_FLAG = LINK_GO_U2_FLAG;
    }
    if(USBSS->LINK_INT_FLAG & LINK_GO_U3_FLAG) // device enter U2
    {
        USB30_Switch_Powermode(POWER_MODE_2);
        USBSS->LINK_INT_FLAG = LINK_GO_U3_FLAG;
    }
}


void EP2_OUT_Callback()//ж
{
    UINT16 rx_len,i;
     UINT8 nump;
     UINT8 status;
     USB30_OUT_Status(ENDP_2,&nump,&rx_len,&status);  //ȡյİ
     printf("OUT:%d\n",nump);
     mDelaymS(1);
     USB30_OUT_ClearIT(ENDP_2);                  //˵״̬ 
     USBSS->UEP2_RX_DMA  = (UINT32)(UINT8 *)endp2RTbuff;           //ͻģʽڵַԶƫ ַ
     USB30_IN_Set( ENDP_2 , ENABLE , ACK , 1 , rx_len);     //ܹ4
     USB30_Send_ERDY( ENDP_2 | IN , 1 );

}

void EP2_IN_Callback()//ϴж
{
    UINT8 nump;
    nump = USB30_IN_Nump( ENDP_2 );                              //s: ʣͰ
    printf("IN:%d\n",nump);
    mDelaymS(1);
    USBSS->UEP2_TX_DMA  = (UINT32)(UINT8 *)endp2RTbuff;       //ͻ DMAַƫ 
    USB30_IN_ClearIT( ENDP_2 );                       //˵״̬ к
    USB30_OUT_Set( ENDP_2 , ACK , 1 );                 //ܹ4
    USB30_Send_ERDY( ENDP_2 | OUT , 1 );             //֪ͨȡ4

}
/***************Endpointn IN Transaction Processing*******************/
void EP1_IN_Callback()
{
//    UINT8 nump;
//    nump = USB30_IN_Nump(ENDP_1);                              //s: ʣͰ
//    if( nump == 0 ){                                        //ȫ
//        USBSS->UEP1_TX_DMA  = (UINT32)(UINT8 *)endp1RTbuff;      //ͻ DMAַƫ 
//        USB30_IN_ClearIT( ENDP_1 );                       //˵״̬ к
//        USB30_OUT_Set( ENDP_1 , ACK , 4 );  //ܹ4
//        USB30_Send_ERDY( ENDP_1 | OUT , 4 );             //֪ͨȡ4
//    }
//    else if( nump == 1 )
//    {
//
//        USB30_IN_ClearIT( ENDP_1 );                       //˵״̬ к
//        USB30_IN_Set( ENDP_1 , ENABLE , ACK , 1 , 1024);     //ܹ4
//        USB30_Send_ERDY( ENDP_1 | IN , 1 );
//    }
//    else if( nump == 2 )
//    {
//        USB30_IN_ClearIT( ENDP_1 );                       //˵״̬ к
//        USB30_IN_Set( ENDP_1 , ENABLE , ACK , 2 , 1024);     //ܹ4
//        USB30_Send_ERDY( ENDP_1 | IN , 2);
//    }
//    else if( nump == 3 )
//    {
//        USB30_IN_ClearIT( ENDP_1 );                       //˵״̬ к
//        USB30_IN_Set( ENDP_1 , ENABLE , ACK , 3 , 1024);     //ܹ4
//        USB30_Send_ERDY( ENDP_1 | IN , 3 );
//    }
}

void EP3_IN_Callback()
{
    UINT8 nump;
    nump = USB30_IN_Nump(ENDP_3);                              //s: ʣͰ
    if( nump == 0 ){                                        //ȫ
        USBSS->UEP3_TX_DMA  = (UINT32)(UINT8 *)endp3RTbuff;      //ͻ DMAַƫ 
        USB30_IN_ClearIT( ENDP_3 );                       //˵״̬ к
        USB30_OUT_Set( ENDP_3 , ACK , 4 );                //ܹ4
        USB30_Send_ERDY( ENDP_3 | OUT , 4 );             //֪ͨȡ4
    }
    else if( nump == 1 )
    {
        USB30_IN_ClearIT( ENDP_3 );                       //˵״̬ к
        USB30_IN_Set( ENDP_3 , ENABLE , ACK , 1 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_3 | IN , 1 );
    }
    else if( nump == 2 )
    {
        USB30_IN_ClearIT( ENDP_3 );                       //˵״̬ к
        USB30_IN_Set( ENDP_3 , ENABLE , ACK , 2 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_3 | IN , 2);
    }
    else if( nump == 3 )
    {
        USB30_IN_ClearIT( ENDP_3 );                       //˵״̬ к
        USB30_IN_Set( ENDP_3 , ENABLE , ACK , 3 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_3 | IN , 3 );
    }
}


void EP4_IN_Callback()
{
    UINT8 nump;
    nump = USB30_IN_Nump(ENDP_4);                              //s: ʣͰ
    if( nump == 0 ){                                        //ȫ
        USBSS->UEP4_TX_DMA  = (UINT32)(UINT8 *)endp4RTbuff;    //ͻ DMAַƫ 
        USB30_IN_ClearIT( ENDP_4 );                       //˵״̬ к
        USB30_OUT_Set( ENDP_4 , ACK , 4 );  //ܹ4
        USB30_Send_ERDY( ENDP_4 | OUT , 4 );             //֪ͨȡ4
    }
    else if( nump == 1 )
    {
        USB30_IN_ClearIT( ENDP_4 );                       //˵״̬ к
        USB30_IN_Set( ENDP_4 , ENABLE , ACK , 1 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_4 | IN , 1 );
    }
    else if( nump == 2 )
    {
        USB30_IN_ClearIT( ENDP_4 );                       //˵״̬ к
        USB30_IN_Set( ENDP_4 , ENABLE , ACK , 2 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_4 | IN , 2);
    }
    else if( nump == 3 )
    {
        USB30_IN_ClearIT( ENDP_4 );                       //˵״̬ к
        USB30_IN_Set( ENDP_4 , ENABLE , ACK , 3 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_4 | IN , 3 );
    }
}


void EP5_IN_Callback()
{
    UINT8 nump;
    nump = USB30_IN_Nump(ENDP_5);                              //s: ʣͰ
    if( nump == 0 ){                                        //ȫ
        USBSS->UEP5_TX_DMA  = (UINT32)(UINT8 *)endp5RTbuff;      //ͻ DMAַƫ 
        USB30_IN_ClearIT( ENDP_5 );                       //˵״̬ к
        USB30_OUT_Set( ENDP_5 , ACK , 4 );  //ܹ4
        USB30_Send_ERDY( ENDP_5 | OUT , 4 );             //֪ͨȡ4
    }
    else if( nump == 1 )
    {

        USB30_IN_ClearIT( ENDP_5 );                       //˵״̬ к
        USB30_IN_Set( ENDP_5 , ENABLE , ACK , 1 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_5 | IN , 1 );
    }
    else if( nump == 2 )
    {
        USB30_IN_ClearIT( ENDP_5 );                       //˵״̬ к
        USB30_IN_Set( ENDP_5 , ENABLE , ACK , 2 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_5 | IN , 2);
    }
    else if( nump == 3 )
    {
        USB30_IN_ClearIT( ENDP_5 );                       //˵״̬ к
        USB30_IN_Set( ENDP_5 , ENABLE , ACK , 3 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_5 | IN , 3 );
    }
}


void EP6_IN_Callback()
{
    UINT8 nump;
    nump = USB30_IN_Nump(ENDP_6);                              //s: ʣͰ
    if( nump == 0 ){                                        //ȫ
        USBSS->UEP6_TX_DMA  = (UINT32)(UINT8 *)endp6RTbuff;       //ͻ DMAַƫ 
        USB30_IN_ClearIT( ENDP_6 );                       //˵״̬ к
        USB30_OUT_Set( ENDP_6 , ACK , 4 );  //ܹ4
        USB30_Send_ERDY( ENDP_6 | OUT , 4 );             //֪ͨȡ4
    }
    else if( nump == 1 )
    {

        USB30_IN_ClearIT( ENDP_6 );                       //˵״̬ к
        USB30_IN_Set( ENDP_6 , ENABLE , ACK , 1 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_6 | IN , 1 );
    }
    else if( nump == 2 )
    {
        USB30_IN_ClearIT( ENDP_6 );                       //˵״̬ к
        USB30_IN_Set( ENDP_6 , ENABLE , ACK , 2 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_6 | IN , 2);
    }
    else if( nump == 3 )
    {
        USB30_IN_ClearIT( ENDP_6 );                       //˵״̬ к
        USB30_IN_Set( ENDP_6 , ENABLE , ACK , 3 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_6 | IN , 3 );
    }
}


void EP7_IN_Callback()
{
    UINT8 nump;
    nump = USB30_IN_Nump(ENDP_7);                              //s: ʣͰ
    if( nump == 0 ){                                        //ȫ
        USBSS->UEP7_TX_DMA  = (UINT32)(UINT8 *)endp7RTbuff;      //ͻ DMAַƫ 
        USB30_IN_ClearIT( ENDP_7 );                       //˵״̬ к
        USB30_OUT_Set( ENDP_7 , ACK , 4 );  //ܹ4
        USB30_Send_ERDY( ENDP_7 | OUT , 4 );             //֪ͨȡ4
    }
    else if( nump == 1 )
    {

        USB30_IN_ClearIT( ENDP_7 );                       //˵״̬ к
        USB30_IN_Set( ENDP_7 , ENABLE , ACK , 1 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_7 | IN , 1 );
    }
    else if( nump == 2 )
    {
        USB30_IN_ClearIT( ENDP_7 );                       //˵״̬ к
        USB30_IN_Set( ENDP_7 , ENABLE , ACK , 2 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_7 | IN , 2);
    }
    else if( nump == 3 )
    {
        USB30_IN_ClearIT( ENDP_7 );                       //˵״̬ к
        USB30_IN_Set( ENDP_7 , ENABLE , ACK , 3 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_7 | IN , 3 );
    }
}


/***************Endpointn OUT Transaction Processing*******************/
void EP1_OUT_Callback()
{
	UINT16 rx_len,i;
	UINT8 nump;
	UINT8 status;
	USB30_OUT_Status(ENDP_1,&nump,&rx_len,&status);  //ȡյİ

	if(nump == 0){
	    USB30_OUT_ClearIT(ENDP_1);                  //˵״̬ 
	    for(i=0;i<1024;i++){                                //ȡش
	        endp1RTbuff[i] = ~endp1RTbuff[i];
	    }
	    USBSS->UEP1_RX_DMA  = (UINT32)(UINT8 *)endp1RTbuff;        //ͻģʽڵַԶƫ ַ
	    USB30_IN_Set( ENDP_1 , ENABLE , ACK , 4 , 1024);     //ܹ4
	    USB30_Send_ERDY( ENDP_1 | IN , 4 );
	}
	else if(nump == 1){
	    USB30_OUT_ClearIT(ENDP_1);
	    USB30_OUT_Set(ENDP_1,ACK,1);       //ܹһ
	    USB30_Send_ERDY(ENDP_1|OUT,1);       //֪ͨ·һ
	}
    else if(nump == 2){
        USB30_OUT_ClearIT(1);
        USB30_OUT_Set(ENDP_1,ACK,2);       //ܹһ
        USB30_Send_ERDY(ENDP_1|OUT,2);       //֪ͨ·һ
    }
	else if(nump == 3){
	    USB30_OUT_ClearIT(1);
	    USB30_OUT_Set(ENDP_1,ACK,3);       //ܹһ
	    USB30_Send_ERDY(ENDP_1|OUT,3);       //֪ͨ·һ
	}
}




void EP3_OUT_Callback()
{
    UINT16 rx_len,i;
    UINT8 nump;
    UINT8 status;
    USB30_OUT_Status(ENDP_3,&nump,&rx_len,&status);  //ȡյİ

    if(nump == 0){
        USB30_OUT_ClearIT(ENDP_3);                  //˵״̬ 
        for(i=0;i<1024;i++){                                //ȡش
            endp3RTbuff[i] = ~endp3RTbuff[i];
        }
        USBSS->UEP3_RX_DMA  = (UINT32)(UINT8 *)endp3RTbuff;           //ͻģʽڵַԶƫ ַ
        USB30_IN_Set( ENDP_3 , ENABLE , ACK , 4 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_3 | IN , 4 );
    }
    else if(nump == 1){
        USB30_OUT_ClearIT(ENDP_3);
        USB30_OUT_Set(ENDP_3,ACK,1);       //ܹһ
        USB30_Send_ERDY(ENDP_3|OUT,1);       //֪ͨ·һ
    }
    else if(nump == 2){
        USB30_OUT_ClearIT(ENDP_3);
        USB30_OUT_Set(ENDP_3,ACK,2);       //ܹһ
        USB30_Send_ERDY(ENDP_3|OUT,2);       //֪ͨ·һ
    }
    else if(nump == 3){
        USB30_OUT_ClearIT(ENDP_3);
        USB30_OUT_Set(ENDP_3,ACK,3);       //ܹһ
        USB30_Send_ERDY(ENDP_3|OUT,3);       //֪ͨ·һ
    }
}


void EP4_OUT_Callback()
{
    UINT16 rx_len,i;
    UINT8 nump;
    UINT8 status;
    USB30_OUT_Status(ENDP_4,&nump,&rx_len,&status);  //ȡյİ

    if(nump == 0){
        USB30_OUT_ClearIT(ENDP_4);                  //˵״̬ 
        for(i=0;i<1024;i++){                                //ȡش
            endp4RTbuff[i] = ~endp4RTbuff[i];
        }
        USBSS->UEP4_RX_DMA  = (UINT32)(UINT8 *)endp4RTbuff;         //ͻģʽڵַԶƫ ַ
        USB30_IN_Set( ENDP_4 , ENABLE , ACK , 4 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_4 | IN , 4 );
    }
    else if(nump == 1){
        USB30_OUT_ClearIT(ENDP_4);
        USB30_OUT_Set(ENDP_4,ACK,1);       //ܹһ
        USB30_Send_ERDY(ENDP_4|OUT,1);       //֪ͨ·һ
    }
    else if(nump == 2){
        USB30_OUT_ClearIT(ENDP_4);
        USB30_OUT_Set(ENDP_4,ACK,2);       //ܹһ
        USB30_Send_ERDY(ENDP_4|OUT,2);       //֪ͨ·һ
    }
    else if(nump == 3){
        USB30_OUT_ClearIT(ENDP_4);
        USB30_OUT_Set(ENDP_4,ACK,3);       //ܹһ
        USB30_Send_ERDY(ENDP_4|OUT,3);       //֪ͨ·һ
    }
}


void EP5_OUT_Callback()
{
    UINT16 rx_len,i;
    UINT8 nump;
    UINT8 status;
    USB30_OUT_Status(ENDP_5,&nump,&rx_len,&status);  //ȡյİ

    if(nump == 0){
        USB30_OUT_ClearIT(ENDP_5);                  //˵״̬ 
        for(i=0;i<1024;i++){                                //ȡش
            endp5RTbuff[i] = ~endp5RTbuff[i];
        }
        USBSS->UEP5_RX_DMA  = (UINT32)(UINT8 *)endp5RTbuff;          //ͻģʽڵַԶƫ ַ
        USB30_IN_Set( ENDP_5 , ENABLE , ACK , 4 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_5 | IN , 4 );
    }
    else if(nump == 1){
        USB30_OUT_ClearIT(ENDP_5);
        USB30_OUT_Set(ENDP_5,ACK,1);       //ܹһ
        USB30_Send_ERDY(ENDP_5|OUT,1);       //֪ͨ·һ
    }
    else if(nump == 2){
        USB30_OUT_ClearIT(ENDP_5);
        USB30_OUT_Set(ENDP_5,ACK,2);       //ܹһ
        USB30_Send_ERDY(ENDP_5|OUT,2);       //֪ͨ·һ
    }
    else if(nump == 3){
        USB30_OUT_ClearIT(ENDP_5);
        USB30_OUT_Set(ENDP_5,ACK,3);       //ܹһ
        USB30_Send_ERDY(ENDP_5|OUT,3);       //֪ͨ·һ
    }
}


void EP6_OUT_Callback()
{
    UINT16 rx_len,i;
    UINT8 nump;
    UINT8 status;
    USB30_OUT_Status(ENDP_6,&nump,&rx_len,&status);  //ȡյİ

    if(nump == 0){
        USB30_OUT_ClearIT(ENDP_6);                  //˵״̬ 
        for(i=0;i<1024;i++){                                //ȡش
            endp6RTbuff[i] = ~endp6RTbuff[i];
        }
        USBSS->UEP6_RX_DMA  = (UINT32)(UINT8 *)endp6RTbuff;        //ͻģʽڵַԶƫ ַ
        USB30_IN_Set( ENDP_6 , ENABLE , ACK , 4 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_6 | IN , 4 );
    }
    else if(nump == 1){
        USB30_OUT_ClearIT(ENDP_6);
        USB30_OUT_Set(ENDP_6,ACK,1);       //ܹһ
        USB30_Send_ERDY(ENDP_6|OUT,1);       //֪ͨ·һ
    }
    else if(nump == 2){
        USB30_OUT_ClearIT(ENDP_6);
        USB30_OUT_Set(ENDP_6,ACK,2);       //ܹһ
        USB30_Send_ERDY(ENDP_6|OUT,2);       //֪ͨ·һ
    }
    else if(nump == 3){
        USB30_OUT_ClearIT(ENDP_6);
        USB30_OUT_Set(ENDP_6,ACK,3);       //ܹһ
        USB30_Send_ERDY(ENDP_6|OUT,3);       //֪ͨ·һ
    }
}


void EP7_OUT_Callback()
{
    UINT16 rx_len,i;
    UINT8 nump;
    UINT8 status;
    USB30_OUT_Status(ENDP_7,&nump,&rx_len,&status);  //ȡյİ

    if(nump == 0){
        USB30_OUT_ClearIT(ENDP_7);                  //˵״̬ 
        for(i=0;i<1024;i++){                                //ȡش
            endp7RTbuff[i] = ~endp7RTbuff[i];
        }
        USBSS->UEP7_RX_DMA  = (UINT32)(UINT8 *)endp7RTbuff;           //ͻģʽڵַԶƫ ַ
        USB30_IN_Set( ENDP_7 , ENABLE , ACK , 4 , 1024);     //ܹ4
        USB30_Send_ERDY( ENDP_7 | IN , 4 );
    }
    else if(nump == 1){
        USB30_OUT_ClearIT(ENDP_7);
        USB30_OUT_Set(ENDP_7,ACK,1);       //ܹһ
        USB30_Send_ERDY(ENDP_7|OUT,1);       //֪ͨ·һ
    }
    else if(nump == 2){
        USB30_OUT_ClearIT(ENDP_7);
        USB30_OUT_Set(ENDP_7,ACK,2);       //ܹһ
        USB30_Send_ERDY(ENDP_7|OUT,2);       //֪ͨ·һ
    }
    else if(nump == 3){
        USB30_OUT_ClearIT(ENDP_7);
        USB30_OUT_Set(ENDP_7,ACK,3);       //ܹһ
        USB30_Send_ERDY(ENDP_7|OUT,3);       //֪ͨ·һ
    }
}

/*******************************************************************************
* Function Name  : USB30_ITP_Callback
* Description    : USB3.0 ITPص
* Input          : None
* Return         : None
*******************************************************************************/
void  USB30_ITP_Callback(UINT32 ITPCounter)
{

}
